import smtplib
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from django.core.mail import EmailMultiAlternatives
from django.template.loader import get_template


from django.template.loader import render_to_string
import time

status = 'dev'
#status = 'prod'
sleepAfterSend = 5


from django.conf import settings
import os
from django import setup
# Make sure Django settings are configured
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'server.settings')
setup()


# Email credentials
email_address = "community@risefor.org"


#Create recipient list from file
if status == 'dev':
    recipient_list = []
    emailListFile = './static/csv/dev_email-list.csv'
else:
    recipient_list = []
    emailListFile = './static/csv/email-list.csv'
    
with open(emailListFile, encoding='utf-8') as emailList:
    count = 0
    for e in emailList:
        e = e.replace('\n','')
        e = e.replace(' ','')
        recipient_list.append(e)
        count += 1
        print(count,e)

# Email template
# email_subject = "Interpelle le gouvernement Français pour mettre fin au génocide à Gaza"
email_subject = "Actions en ligne - Prêt.e à agir ? :)"
# email_text = """
# La France doit appliquer le droit international

# - La situation

# Depuis plus de six mois, la situation à Gaza, et en territoire Palestiniens occupés, atteint des niveaux de violence rappelant les heures les plus sombres de l'histoire de l'humanité.

# La France, comme la majorité des États dans le monde, est signataire de la Convention pour la prévention et la répression du crime de génocide¹. La signature de cette Convention Internationale exige que les État signataires mettent en place toutes les mesures nécessaires pour prévenir un génocide.

# Depuis l’ordonnance rendu par la Cour Internationale de Justice le 26 Janvier 2024², reconnaissant un risque de génocide la Gaza, la France a le devoir de prendre toutes les mesures nécessaires et effectives pour prévenir le génocide.

# Ce devoir a été rappelé par la Rapporteuse Indépendante de l’ONU Francesca Albanes le 24 Mars 2024 lors de la remise de son rapport sur la situation en Palestine, intitulé “Anatomie d’un Génocide³”

# Interpellez le gouvernement pour demander de :
# - Mettre en place un embargo économique et militaire de l'État d'Israël
# - Soutenir la plainte de l'Afrique du Sud à la Cour internationale de Justice (CIJ)
# - Proposer et soutenir les sanctions à l'ONU
# - Soutenir le droit de retour du peuple palestinien⁴
# - Rejoindre l’Espagne et l’Irlande dans la reconnaissance de l’État de Palestine
# - Dénoncer publiquement les colonisations de terres en Cisjordanie occupée, le dernier exemple remontant à 800 hectares il y a quelques semaines

# L’occupation de la Palestine par Israël est l’occupation militaire la plus longue et l’une des plus meurtrières au monde. Depuis des décennies, elle se caractérise par des violations généralisées et systématiques des droits humains à l’encontre du peuple Palestinien.

# Les mesures demandées sont le minimum que l’État Français doit mettre en place pour faire pression sur le gouvernement d’Israël afin de mettre fin à ce génocide.

# J'interpelle le gouvernement : https://palestine.risefor.org/s/stop-genocide-la-france-doit-appliquer-le-droit-internationale-U262E

# Faisons en sorte que notre gouvernement ne puisse plus "ignorer" la situation :
# En manifestation, par email, sur Twitter, au téléphone, interpellons de manière continue notre gouvernement pour mettre fin à la complicité de la France.


# - Saturons les lignes de l'Elysée pour mettre fin au Génocide !

# En journée, faisons sonner le téléphone. Si nous prenons chacun.e quelques minutes dans notre journée, nous pouvons saturer leur ligne téléphonique.
# Que les équipes au coin "pause café" de l'Élysée et du ministère ne parle que de ça !

# Nous restons disponibles sur community@risefor.org
# A bientôt!
# L'équipe Risefor Palestine


# P.S: Vous avez reçu cet e-mail car vous avez participé à une action sur Risefor. Lors de la participation, vous avez opt-in pour recevoir les nouvelles actions ou participé avant la mise en place du bouton "opt-in"
# Nous avons pensé que le sujet est suffisamment important pour nous permettre de vous envoyer cet email.
# Cela ne se reproduira plus (hors opt-in explicite).
# Si nous vous avons dérangé, nous vous prions de bien vouloir nous excuser.

# Sources:
# ¹ Convention pour la prévention et la répression du crime de génocide : https://www.ohchr.org/fr/instruments-mechanisms/instruments/convention-prevention-and-punishment-crime-genocide
# ² Ordonnance de la CJI du 26 janvier 2024 : https://www.icj-cij.org/fr/node/203447
# ³ Rapport “Anatomie d’un Génocide”, de Francesca Albanes la rapporteuse spéciale sur la situation des droits de l’homme dans les territoires palestiniens: https://www.ohchr.org/.../a-hrc-55-73-auv.pdf
# ⁴ Résolution 194 de l'Assemblée générale des Nations unies : https://www.un.org/unispal/wp-content/uploads/2016/06/ARES194III.pdf
# """

# with open("templates/email_templates/emailing-action.html", "r") as file:
#     email_html = file.read()


# with open("templates/email_templates/newsletter-ongoingActions.html", "r") as file:
#     email_html = file.read()
email_html = render_to_string("email_templates/newsletter-ongoingActions.html")

emailcount = 0
for recipient_email in recipient_list:
    emailcount += 1
    email = EmailMultiAlternatives( 
            subject=email_subject,
            # body=email_text, #fix here once we have a final email
            body=email_html,
            from_email=email_address,
            to=[recipient_email],
        )
    email.attach_alternative(email_html, "text/html")
    # email.attach_file('./media/stop-genocide-pal.png')
    
    print('sending email n',emailcount,'to',recipient_email)
    email.send()

    time.sleep(sleepAfterSend)



print(emailcount,'emails have been sent')
